<template>
  <q-item
    v-if="!hasChildren"
    :to="menuLink"
  >
    <q-item-main>
      {{ item.menu_name }}
    </q-item-main>
    <q-item-side
      v-if="hasChildren"
      side="right"
    >
      <q-icon
        :name="`arrow_${!isCollapsed ? 'up' : 'down'}ward`"
      />
    </q-item-side>
  </q-item>
  <q-collapsible
    class="sidebar__item"
    v-else
    :label="item.menu_name"
    :to="!!item.collection_id ? {name: 'reporting-report', params: {item: this.item.id}}: undefined"
    :icon-toggle="!!item.collection_id"
    link
  >
    <item
      v-for="subItem in leafs[item.id]"
      :key="subItem.id"
      :item="subItem"
      :leafs="leafs"
    />
  </q-collapsible>
</template>

<script>
  import QIcon from 'quasar-framework/src/components/icon/QIcon';

  export default {
    name: 'item',
    components: { QIcon },
    computed: {
      menuLink() {
        if (this.item.sref === 'B.SetupMenu') {
          return { name: 'reporting-configurator-editor', params: { editor: 'menu' } };
        }
        if (this.item.sref === 'B.SetupCollection') {
          return { name: 'reporting-configurator-editor', params: { editor: 'collections' } };
        }

        if (this.item.sref === 'B.UserTimingImport') {
          return { name: 'user-timing-import' };
        }

        if (this.item.sref === 'B.CameraLocator') {
          return { name: 'camera-locator' };
        }

        return { name: 'reporting-report', params: { item: this.item.id } };
      },
      hasChildren() {
        return !!(this.leafs[this.item.id] || []).length;
      },
    },
    data() {
      return {
        isCollapsed: false,
      };
    },
    methods: {
      click(e) {
        if (this.hasChildren) {
          e.preventDefault();
          this.isCollapsed = !this.isCollapsed;
        }
      },
    },
    props: {
      item: {
        type: Object,
      },
      leafs: {
        type: Object,
      },
    },
  };
</script>

<style lang="css">
  .sidebar__item .q-collapsible-sub-item {
    padding: 0 0 0 10px !important;
  }
</style>
